/*
Produzido por Leandro e Greice 
Faculdade de Engenharia Eltrica e Computao - UNICAMP
IA725
Verso final 04/07/2008
*/
// caapa: (10,7,0) <-> (-10,7,0)
//tampo da mesa em 6.5
//

#include <windows.h> 
#include <math.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <GL/glut.h>
#include <GL/glext.h>
#include <GL/gl.h>
#include "glm.c"
#include "image.c"
#include "Camera.h" 

using namespace std;

Camera *cam;

// Iluminacao - definicao das cores da luz
GLfloat preto[]       = { 0.0, 0.0, 0.0 };
GLfloat vermelho[]    = { 1.0, 0.0, 0.0 };
GLfloat verde[]       = { 0.0, 1.0, 0.0 }; 
GLfloat verdeclaro[]  = { 0.0, 0.5, 0.0 }; 
GLfloat amarelo[]     = { 1.0, 1.0, 0.0 }; 
GLfloat azul[]        = { 0.0, 0.0, 1.0 };
GLfloat magenta[]     = { 1.0, 0.0, 1.0 }; 
GLfloat ciano[]       = { 0.0, 1.0, 1.0 };
GLfloat branco[]      = { 1.0, 1.0, 1.0 };
GLfloat cinza[]       = { 0.5, 0.5, 0.5 };
GLfloat cinzaclaro[]  = { 0.2, 0.2, 0.2 };
GLfloat cinzaescuro[] = { 0.8, 0.8, 0.8 };


GLfloat Posicao_Luz0[]  = { 10.0, 50.0, 0.0, 1.0};
//GLfloat Posicao_Luz2[]  = { 10.0, 0.0, 0.0, 1.0};
//GLfloat Posicao_Luz1[]  = { 0.0, 0.0,  0.0, 1.0};
//GLfloat Direcao_Luz1[]  = { 10.0, 0.0, 10.0, 1.0};

int acao = 1; // variavel de definicao da luz - ligado 1 desligado 0


//////////////////// DESENHO ////////////////////
GLMmodel* drawmodel(char *string, char *type);

/////////////// PRINCIPAL ////////////

void luzes(int status);
void makeCheckImage(void);
void listas();
void init(void);
void carregar_texturas(GLuint id, char *NomeArquivo);
void keyboard(unsigned char k, int x, int y);
void special(int k, int x, int y);
void display(void);
void reshape (int w, int h);
void move_taco(float x, float y, float ang);
void move_bolinha(float angulo);

//variaveis das listas
GLuint lista_mesa1, lista_sala, lista_mesa2, lista_bolinha1, lista_mesa, lista_sofa, lista_bolinha2, lista_bolinha3, lista_bolinha4, lista_taco, lista_chao, lista_porta, lista_janela;
int x,y;
float lado=0, frente=1.0, angulo=0;
float ang_col = 0, x_b1 = 0, y_b1 = 0;
int F=0;

//VARIAVEIS DO LOADER
GLMmodel* pmodel1 = NULL;

//VARIAVEIS DO SISTEMA DE TEXTURA
GLuint textura[4];                        //Armazena Texturas RGB


GLMmodel* drawmodel(char *string, char *type)
{
    GLMmodel* pmodel = NULL;
    if (!pmodel) {
        pmodel = glmReadOBJ(string);
        if (!pmodel) exit(0);
        glmFacetNormals(pmodel);
        glmVertexNormals(pmodel, 0);

    }    

return pmodel;
}

void carregar_texturas(GLuint id, char *NomeArquivo)
{

IMAGE *img;
GLenum gluerr;
glGenTextures(1, &textura[id]);
glBindTexture(GL_TEXTURE_2D, textura[id]);
  
if(!(img=ImageLoad(NomeArquivo))) 
    {
    MessageBox(NULL,"Falha ao encontrar texturas.","Erro Fatal",MB_OK|MB_ICONERROR ); 
    exit(-1); 
    }

gluerr=gluBuild2DMipmaps(GL_TEXTURE_2D, 3, img->sizeX, img->sizeY, GL_RGB,GL_UNSIGNED_BYTE, (GLvoid *)(img->data));
			   
if(gluerr)
    {
    MessageBox(NULL,"Falha ao criar mipmaps.","Erro Fatal",MB_OK|MB_ICONERROR ); 
    exit(-1);
    }

glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST );
glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL); 
}
void listas(){

    lista_mesa1   =  glGenLists(1); 
    lista_mesa2   =  glGenLists(1); 
    lista_chao    =  glGenLists(1); 
	lista_bolinha1 =  glGenLists(1);
	lista_bolinha2 =  glGenLists(1);
	lista_bolinha3 =  glGenLists(1);
	lista_bolinha4 =  glGenLists(1);
	lista_taco  =  glGenLists(1);
	lista_sala  =  glGenLists(1);
	lista_mesa  =  glGenLists(1);
	lista_sofa  =  glGenLists(1);
	lista_porta = glGenLists(1);
	lista_janela = glGenLists(1);

/************ SALA ************/
	//carrega a textura e o obj
	glNewList(lista_sala, GL_COMPILE); 
	   glPushMatrix();
	   carregar_texturas(3,"texturas/papel_parede_velho.rgb");cout<<"Sala...";
	   pmodel1=drawmodel("modelos/sala.obj","texture");cout<<" ok!...\n";
       glEnable(GL_TEXTURE_2D);  
       glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
        glBindTexture(GL_TEXTURE_2D,textura[3]);
	   glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
	   glDisable(GL_TEXTURE_2D);  
       glPopMatrix();
	glEndList();


/************ TAMPO DA MESA ************/
	//carrega a textura e o obj
	glNewList(lista_mesa1, GL_COMPILE); 
	   glPushMatrix();
	   carregar_texturas(3,"texturas/mesa_fundo.rgb");cout<<"Mesa...";
	   pmodel1=drawmodel("modelos/mesa1.obj","texture");cout<<"ok!...\n";
       glEnable(GL_TEXTURE_2D);  
       glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
       glBindTexture(GL_TEXTURE_2D,textura[3]);
	   glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
	   glDisable(GL_TEXTURE_2D);  
       glPopMatrix();
	glEndList();


/************ BASE DA MESA ************/

	glNewList(lista_mesa2, GL_COMPILE); 
		glPushMatrix(); 
		carregar_texturas(3,"texturas/madeira1.rgb");cout<<"Mesa...";  
        pmodel1=drawmodel("modelos/mesa2.obj","texture");cout<<"...\n";	    
		glEnable(GL_TEXTURE_2D); 
        glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE); 
        glBindTexture(GL_TEXTURE_2D,textura[3]);
    	glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
    	glDisable(GL_TEXTURE_2D); 
        glPopMatrix();
	glEndList();


/************ BOLINHAS ************/
glNewList(lista_bolinha1, GL_COMPILE); 
		glPushMatrix(); 
		glColor3f(1.0f, 0.0f, 0.0f);
        glTranslatef(0.0, 7.5, 0.0 );
       glutSolidSphere(1,30,30);
		glPopMatrix();
 glEndList();
 
 glNewList(lista_bolinha2, GL_COMPILE); 
		glPushMatrix(); 
		glColor3f(1.0f, 1.0f, 0.0f); //glMaterial(...)
        glTranslatef(2, 7.5,10 );
        glutSolidSphere(1,30,30);
		glPopMatrix();
 glEndList();
 glNewList(lista_bolinha3, GL_COMPILE); 
		glPushMatrix(); 
		glColor3f(0.0f, 0.0f, 1.0f);
       glTranslatef(4, 7.5,10 );
       glutSolidSphere(1,30,30);
		glPopMatrix();
 glEndList();
 glNewList(lista_bolinha4, GL_COMPILE); 
		glPushMatrix(); 
		glColor3f(0.0f, 1.0f, 0.0f);
       glTranslatef(6, 7.5,10 );
       glutSolidSphere(1,30,30);
		glPopMatrix();
 glEndList();

 /************ TACO ************/
	//carrega a textura e o obj
	glNewList(lista_taco, GL_COMPILE); 
	   glPushMatrix();
	   glTranslatef(0.0, 0.0,1.0 );
	   carregar_texturas(3,"texturas/taco.rgb");cout<<"Taco ...";
	   pmodel1=drawmodel("modelos/taco.obj","texture");cout<<"ok!\n";
       glEnable(GL_TEXTURE_2D);  
       glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
       glBindTexture(GL_TEXTURE_2D,textura[3]);
	   glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
	   glDisable(GL_TEXTURE_2D);  
       glPopMatrix();
	glEndList();


 /************ MESINHA ************/
	//carrega a textura e o obj
	glNewList(lista_mesa, GL_COMPILE); 
	   glPushMatrix();
	    glTranslatef(-25, 0.0, 25); 
	   carregar_texturas(3,"texturas/granito.rgb");cout<<"Mesinha...";
	   pmodel1=drawmodel("modelos/mesa.obj","texture");cout<<"ok!\n";
       glEnable(GL_TEXTURE_2D);  
       glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
       glBindTexture(GL_TEXTURE_2D,textura[3]);
	   glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
	   glDisable(GL_TEXTURE_2D);  
       glPopMatrix();
	glEndList();

 /************ SOFA ************/
	//carrega a textura e o obj
	glNewList(lista_sofa, GL_COMPILE); 
	   glPushMatrix();
	   glRotatef( 90,0.0,1.0,0.0);
	    glTranslatef(0.0, 0.0, -25); 
	   carregar_texturas(3,"texturas/sofa.sgi");cout<<"Sofa...";
	   pmodel1=drawmodel("modelos/sofa1.obj","texture");cout<<"ok!\n";
       glEnable(GL_TEXTURE_2D);  
       glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
       glBindTexture(GL_TEXTURE_2D,textura[3]);
	   glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
	   glDisable(GL_TEXTURE_2D);  
       glPopMatrix();
	glEndList();

/************ CHAO ************/

		//carrega a textura e o obj
	glNewList(lista_chao, GL_COMPILE); 
	   glPushMatrix();
	   //carregar_texturas(3,"texturas/chao2.rgb");cout<<"Chao...";
	   carregar_texturas(3,"texturas/piso_taco01.rgb");cout<<"Chao...";
	   pmodel1=drawmodel("modelos/chao.obj","texture");cout<<"ok!\n";
       glEnable(GL_TEXTURE_2D);  
       glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
       glBindTexture(GL_TEXTURE_2D,textura[3]);
	   glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
	   glDisable(GL_TEXTURE_2D);  
       glPopMatrix();
	glEndList();

/************ PORTA ************/
		//carrega a textura e o obj
	glNewList(lista_porta, GL_COMPILE); 
	   glPushMatrix();
	   carregar_texturas(3,"texturas/porta.sgi");cout<<"Porta...";
	   pmodel1=drawmodel("modelos/porta.obj","texture");cout<<"ok!\n";
       glEnable(GL_TEXTURE_2D);  
       glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
       glBindTexture(GL_TEXTURE_2D,textura[3]);
	   glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
	   glDisable(GL_TEXTURE_2D);  
       glPopMatrix();
	glEndList();

/************ JANELA ************/
		//carrega a textura e o obj
	glNewList(lista_janela, GL_COMPILE); 
	   glPushMatrix();
	   carregar_texturas(3,"texturas/janela.rgb");cout<<"Janela...";
	   pmodel1=drawmodel("modelos/janela.obj","texture");cout<<"ok!\n";
       glEnable(GL_TEXTURE_2D);  
       glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
       glBindTexture(GL_TEXTURE_2D,textura[3]);
	   glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
	   glDisable(GL_TEXTURE_2D);  
       glPopMatrix();
	glEndList();

 }



void init(void)
{
	
  glClearColor(0.0, 0.0, 0.0, 0.0);
  glShadeModel (GL_SMOOTH);
  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  
// Inicializa display lists
  cout<<"Carregando listas...\n ";
  listas();
  cout<<"Listas carregadas!! \n";
}
void display(void)
{
glClearColor( 1.0, 1.0, 1.0, 0.0 );
  glShadeModel(GL_SMOOTH);  
  glEnable(GL_DEPTH_TEST); 
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT|GL_STENCIL_BUFFER_BIT); 
   //insere a camera
  cam->AtualizarPosicao();
  glClearColor( 0.0, 0.0, 0.0, 0.0 );
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
  glShadeModel(GL_SMOOTH);
  glEnable(GL_DEPTH_TEST); 
  glCallList(lista_sala);
  glCallList(lista_mesa1);
  glCallList(lista_mesa2);
  glCallList(lista_chao);
  glCallList(lista_sofa);
  glCallList(lista_mesa);
  glCallList(lista_porta);
  glCallList(lista_janela);
  glCallList(lista_bolinha3);
  glCallList(lista_bolinha4);

  glRotatef( angulo,0.0,1.0,0.0);
  glTranslatef(lado, 0.0, frente);  
  glCallList(lista_taco);
  move_bolinha(angulo);
  glutSwapBuffers();
}
void move_bolinha(float angulo){
if ((lado == y_b1) && (frente == x_b1)){
		y_b1 =  (y_b1+1)*sin(angulo);
		x_b1 = (x_b1+1)*cos(angulo);
		glTranslatef(x_b1, 0.0, y_b1); 
		glCallList(lista_bolinha1);
  }else{
	  glTranslatef(x_b1, 0.0, y_b1); 
	  glCallList(lista_bolinha1);}
 
}

void keyboard(unsigned char k, int x, int y)
{
  switch (k) {
	  case 'w':
            cam->moveFront(); //move para frente
            break;
        case 's':
            cam->moveBack(); //move para trs
            break;
        case 'q': // sobe a camera
            cam->moveUp();
            break;
        case 'e': //desce a camera
            cam->moveDown();
            break;
        case 'a': //move para a esquerda
            cam->moveLeft();
            break;
        case 'd': // move para direita
            cam->moveRight();
            break;
		case 'm': //inclina o taco p/ direita
            move_taco(0,0,-0.45);
            break;
		case 'n': //inclina o taco p/ esquerda
            move_taco(0,0,0.45);
            break;
		case 'b': //gira o taco rapidamente
            move_taco(0,0,45);
            break;
        case '6': //camera p/ esquerda
            cam->Yaw(CAM_LEFT);
            break;
        case '4': //camera p/ direita
            cam->Yaw(CAM_RIGHT); 
            break;
		case 'l': //apaga a luz
			luzes(0);
			break;
        case 'L':
			luzes(1); //acende a luz
			break;
  }
  glutPostRedisplay();
}

//teclado
void special(int k, int x, int y)
{
 
	switch(k) 
    {
        case GLUT_KEY_LEFT: 
			move_taco(0.5,0,0);
			break;
        case GLUT_KEY_RIGHT: 
			move_taco(-0.5,0,0);
			break;
        case GLUT_KEY_UP: 
			move_taco(0,0.5,0);
			break;
        case GLUT_KEY_DOWN: 
			move_taco(0,-0.5,0);
			break;
  }
  glutPostRedisplay();
}
/////////////////////////////////////////////////void glutWarpPointer(int x, int y)

void move_taco(float x, float y, float ang)
{
	cout<<"Taco..." << x << "  " << y << " \n";
   frente = frente + y;
   lado = lado + x;
   angulo = angulo + ang;
}

void reshape(int w, int h)
{
  //cout<<"Reshape \n";
  glViewport(0, 0, (GLsizei)w, (GLsizei)h);
  glMatrixMode(GL_PROJECTION);
  gluPerspective(60.0, (GLfloat)w/(GLfloat)h, 1.0, 100.0);
  glMatrixMode(GL_MODELVIEW);

 
}
void luzes(int status)
{
	//leandro - Iluminacao
 glLightModelfv(GL_LIGHT_MODEL_AMBIENT, vermelho);
 glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_FALSE);
 glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_FALSE);

 glEnable(GL_LIGHTING); 
 glEnable(GL_LIGHT0);
 //glDisable(GL_LIGHT0);
 //glEnable(GL_LIGHT1);
 //glDisable(GL_LIGHT2);

  // Definio das luzes 
	// Luz 1
//Leandro
if (status == 1) //Luz ligada
{
  glLightfv (GL_LIGHT0, GL_AMBIENT,branco);
  glLightfv (GL_LIGHT0, GL_DIFFUSE, branco);
  glLightfv (GL_LIGHT0, GL_SPECULAR, branco);
  glLightfv (GL_LIGHT0, GL_POSITION, Posicao_Luz0);
}
else //Luz desligada
{
  glLightfv (GL_LIGHT0, GL_AMBIENT,branco);
  glLightfv (GL_LIGHT0, GL_DIFFUSE, preto);
  glLightfv (GL_LIGHT0, GL_SPECULAR, preto);
  glLightfv (GL_LIGHT0, GL_POSITION, Posicao_Luz0);
}
  /*
	// Luz 2 
  glLightfv (GL_LIGHT1, GL_AMBIENT,branco);
  glLightfv (GL_LIGHT1, GL_DIFFUSE, verde);
  glLightfv (GL_LIGHT1, GL_SPECULAR, preto);
  glLightfv (GL_LIGHT1, GL_POSITION, Posicao_Luz0);
  glLightfv (GL_LIGHT1, GL_SPOT_DIRECTION, Direcao_Luz1);
	glLightf(GL_LIGHT1, GL_SPOT_CUTOFF, Spot_Angulo);

	// Luz 3
  glLightfv (GL_LIGHT2, GL_AMBIENT, branco);
  glLightfv (GL_LIGHT2, GL_DIFFUSE, preto);
  glLightfv (GL_LIGHT2, GL_SPECULAR, preto);
  glLightfv (GL_LIGHT2, GL_POSITION, Posicao_Luz2);
*/
	glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
	//glEnable(GL_LIGHT1);
	//glDisable(GL_LIGHT2);
  glEnable(GL_DEPTH_TEST);

	// Definio do ambiente
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, preto);
	glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_FALSE);
	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_FALSE);

  glEnable(GL_AUTO_NORMAL);
  glEnable(GL_NORMALIZE);
  glShadeModel(GL_SMOOTH);
}



int main(int argc, char** argv)
{
	
    Ponto3D c;
    c.x = 0;
    c.y = 40;
    c.z = -35.0;


    Ponto3D foco;
	foco.x = 0;
    foco.y = 3.0;
    foco.z = 0;

    
    Ponto3D view;
    view.x = 0;
    view.y = 1;
    view.z = 0;    
    
  cam = new Camera(c, foco, view);
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
  glutInitWindowSize(800, 600);
  glutInitWindowPosition(0,0);
  glutCreateWindow("Billiard Training");
  luzes(acao);
  init();
  
  glutKeyboardFunc(keyboard);
  glutSpecialFunc(special);
  glutDisplayFunc(display);                                 
  glutIdleFunc(display); 
  glutReshapeFunc(reshape);

 
   glutMainLoop();

  delete cam;
  return 0;
}
